import 'package:freezed_annotation/freezed_annotation.dart';
import 'package:tdproto_dart/tdproto_dart.dart';

part 'session.freezed.dart';
part 'session.g.dart';

/// Websocket session.
@freezed
class Session with _$Session {
  const factory Session({
    /// Session id.
    @JsonKey(name: 'uid') required String uid,

    /// Creation datetime.
    @JsonKey(name: 'created') @DateTimeConverter() required DateTime created,

    /// Language code.
    @JsonKey(name: 'lang') String? lang,

    /// Team id.
    @JsonKey(name: 'team') String? team,

    /// Mobile.
    @Default(false) @JsonKey(name: 'is_mobile') bool? isMobile,

    /// Away from keyboard.
    @Default(false) @JsonKey(name: 'afk') bool? afk,

    /// User agent.
    @JsonKey(name: 'useragent') String? useragent,

    /// IP address.
    @JsonKey(name: 'addr') String? addr,
  }) = _Session;

  factory Session.fromJson(Map<String, dynamic> json) => _$SessionFromJson(json);
}
